com.fasterxml.jackson.core.base

## Class ParserMinimalBase

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase

All Implemented Interfaces:
  Versioned, Closeable, AutoCloseable

Direct Known Subclasses:
  ParserBase

    public abstract class ParserMinimalBase
    extends JsonParser

Intermediate base class used by all Jackson `JsonParser` implementations, but does not add any additional fields that depend on particular method of obtaining input.

Note that 'minimal' here mostly refers to minimal number of fields (size) and functionality that is specific to certain types of parser implementations; but not necessarily to number of methods.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

`JsonParser.Feature, JsonParser.NumberType, JsonParser.NumberTypeFP`

### Field Summary

Fields
`protected JsonToken` `_currToken` Last token retrieved via `nextToken()`, if any.
`protected JsonToken` `_lastClearedToken` Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.
`protected StreamReadConstraints` `_streamReadConstraints`
`protected long` `_tokenCount` Current count of tokens, if tracked (see `_trackMaxTokenCount`)
`protected boolean` `_trackMaxTokenCount` Whether or not to track the token count due a `StreamReadConstraints` maxTokenCount > 0.
`protected static BigDecimal` `BD_MAX_INT`
`protected static BigDecimal` `BD_MAX_LONG`
`protected static BigDecimal` `BD_MIN_INT`
`protected static BigDecimal` `BD_MIN_LONG`
`protected static BigInteger` `BI_MAX_INT`
`protected static BigInteger` `BI_MAX_LONG`
`protected static BigInteger` `BI_MIN_INT`
`protected static BigInteger` `BI_MIN_LONG`
`protected static char` `CHAR_NULL`
`protected static int` `INT_0`
`protected static int` `INT_9`
`protected static int` `INT_APOS`
`protected static int` `INT_ASTERISK`
`protected static int` `INT_BACKSLASH`
`protected static int` `INT_COLON`
`protected static int` `INT_COMMA`
`protected static int` `INT_CR`
`protected static int` `INT_e`
`protected static int` `INT_E`
`protected static int` `INT_HASH`
`protected static int` `INT_LBRACKET`
`protected static int` `INT_LCURLY`
`protected static int` `INT_LF`
`protected static int` `INT_MINUS`
`protected static int` `INT_PERIOD`
`protected static int` `INT_PLUS`
`protected static int` `INT_QUOTE`
`protected static int` `INT_RBRACKET`
`protected static int` `INT_RCURLY`
`protected static int` `INT_SLASH`
`protected static int` `INT_SPACE`
`protected static int` `INT_TAB`
`protected static int` `MAX_ERROR_TOKEN_LENGTH` Deprecated. Since 2.16. `ErrorReportConfiguration.getMaxErrorTokenLength()` will be used instead.
`protected static double` `MAX_INT_D`
`protected static long` `MAX_INT_L`
`protected static double` `MAX_LONG_D`
`protected static double` `MIN_INT_D`
`protected static long` `MIN_INT_L`
`protected static double` `MIN_LONG_D`
`protected static byte[]` `NO_BYTES`
`protected static int[]` `NO_INTS`
`protected static int` `NR_BIGDECIMAL`
`protected static int` `NR_BIGINT`
`protected static int` `NR_DOUBLE`
`protected static int` `NR_FLOAT` NOTE!
`protected static int` `NR_INT`
`protected static int` `NR_LONG`
`protected static int` `NR_UNKNOWN`

### Fields inherited from class com.fasterxml.jackson.core.JsonParser

`_features, _requestPayload, DEFAULT_READ_CAPABILITIES`

### Constructor Summary

Constructors
`protected` `ParserMinimalBase()` Deprecated.
`protected` `ParserMinimalBase(int features)` Deprecated.
`protected` `ParserMinimalBase(int features, StreamReadConstraints src)`
`protected` `ParserMinimalBase(StreamReadConstraints src)`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`protected static String` `_ascii(byte[] b)` Deprecated.
`protected static byte[]` `_asciiBytes(String str)` Deprecated.
`protected JsonParseException` `_constructError(String msg, Throwable t)`
`protected JsonLocation` `_currentLocationMinusOne()` Factory method used to provide location for cases where we must read and consume a single "wrong" character (to possibly allow error recovery), but need to report accurate location for that character: if so, the current location is past location we want, and location we want will be "one location earlier".
`protected void` `_decodeBase64(String str, ByteArrayBuilder builder, Base64Variant b64variant)` Helper method that can be used for base64 decoding in cases where encoded content has already been read as a String.
`protected static String` `_getCharDesc(int ch)`
`protected abstract void` `_handleEOF()` Method sub-classes need to implement for verifying that end-of-content is acceptable at current input position.
`protected boolean` `_hasTextualNull(String value)` Helper method used to determine whether we are currently pointing to a String value of "null" (NOT a null token); and, if so, that parser is to recognize and return it similar to if it was real null token.
`protected String` `_longIntegerDesc(String rawNum)`
`protected String` `_longNumberDesc(String rawNum)`
`protected JsonToken` `_nullSafeUpdateToken(JsonToken token)`
`protected void` `_reportError(String msg)`
`protected void` `_reportError(String msg, Object arg)`
`protected void` `_reportError(String msg, Object arg1, Object arg2)`
`protected void` `_reportInputCoercion(String msg, JsonToken inputType, Class<?> targetType)`
`protected void` `_reportInvalidEOF()`
`protected void` `_reportInvalidEOF(String msg, JsonToken currToken)`
`protected void` `_reportInvalidEOFInValue(JsonToken type)`
`protected void` `_reportMissingRootWS(int ch)`
`protected void` `_reportUnexpectedChar(int ch, String comment)`
`protected <T> T` `_reportUnexpectedNumberChar(int ch, String comment)`
`protected void` `_throwInternal()`
`protected <T> T` `_throwInternalReturnAny()`
`protected void` `_throwInvalidSpace(int i)`
`protected JsonToken` `_updateToken(JsonToken token)`
`protected JsonToken` `_updateTokenToNA()`
`protected JsonToken` `_updateTokenToNull()`
`protected void` `_wrapError(String msg, Throwable t)`
`void` `clearCurrentToken()` Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null).
`abstract void` `close()` Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled.
`JsonToken` `currentToken()` Accessor to find which token parser currently points to, if any; null will be returned if none.
`long` `currentTokenCount()` Get an approximate count of the number of tokens that have been read.
`int` `currentTokenId()` Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).
`abstract byte[]` `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`abstract String` `getCurrentName()` Deprecated.
`JsonToken` `getCurrentToken()` Alias for `JsonParser.currentToken()`, may be deprecated sometime after Jackson 2.13 (will be removed from 3.0).
`int` `getCurrentTokenId()` Deprecated.
`JsonToken` `getLastClearedToken()` Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`.
`abstract JsonStreamContext` `getParsingContext()` Method that can be used to access current parsing context reader is in.
`abstract String` `getText()` Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null.
`abstract char[]` `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`abstract int` `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
`abstract int` `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
`boolean` `getValueAsBoolean(boolean defaultValue)` Method that will try to convert value of current token to a boolean.
`double` `getValueAsDouble(double defaultValue)` Method that will try to convert value of current token to a Java double.
`int` `getValueAsInt()` Method that will try to convert value of current token to a Java `int` value.
`int` `getValueAsInt(int defaultValue)` Method that will try to convert value of current token to a int.
`long` `getValueAsLong()` Method that will try to convert value of current token to a long.
`long` `getValueAsLong(long defaultValue)` Method that will try to convert value of current token to a long.
`String` `getValueAsString()` Method that will try to convert value of current token to a `String`.
`String` `getValueAsString(String defaultValue)` Method that will try to convert value of current token to a `String`.
`boolean` `hasCurrentToken()` Method for checking whether parser currently points to a token (and data for that token is available).
`abstract boolean` `hasTextCharacters()` Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
`boolean` `hasToken(JsonToken t)` Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.
`boolean` `hasTokenId(int id)` Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.
`abstract boolean` `isClosed()` Method that can be called to determine whether this parser is closed or not.
`boolean` `isExpectedNumberIntToken()` Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.VALUE_NUMBER_INT`.
`boolean` `isExpectedStartArrayToken()` Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected.
`boolean` `isExpectedStartObjectToken()` Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.
`abstract JsonToken` `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
`JsonToken` `nextValue()` Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers).
`abstract void` `overrideCurrentName(String name)` Method that can be used to change what is considered to be the current (field) name.
`protected void` `reportInvalidNumber(String msg)` Method called to throw an exception for input token that looks like a number based on first character(s), but is not valid according to rules of format.
`protected void` `reportOverflowInt()` Method called to throw an exception for integral (not floating point) input token with value outside of Java signed 32-bit range when requested as `int`.
`protected void` `reportOverflowInt(String numDesc)`
`protected void` `reportOverflowInt(String numDesc, JsonToken inputType)`
`protected void` `reportOverflowLong()` Method called to throw an exception for integral (not floating point) input token with value outside of Java signed 64-bit range when requested as `long`.
`protected void` `reportOverflowLong(String numDesc)`
`protected void` `reportOverflowLong(String numDesc, JsonToken inputType)`
`protected void` `reportUnexpectedNumberChar(int ch, String comment)` Deprecated.
`JsonParser` `skipChildren()` Method that will skip all child tokens of an array or object token that the parser currently points to, if (and only if) stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`.
`StreamReadConstraints` `streamReadConstraints()` Get the constraints to apply when performing streaming reads.

### Methods inherited from class com.fasterxml.jackson.core.JsonParser

`_codec, _constructError, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _constructReadException, _reportUnsupportedOperation, assignCurrentValue, canParseAsync, canReadObjectId, canReadTypeId, canUseSchema, configure, currentLocation, currentName, currentTokenLocation, currentValue, disable, enable, finishToken, getBigIntegerValue, getBinaryValue, getBooleanValue, getByteValue, getCodec, getCurrentLocation, getCurrentValue, getDecimalValue, getDoubleValue, getEmbeddedObject, getFeatureMask, getFloatValue, getFormatFeatures, getInputSource, getIntValue, getLongValue, getNonBlockingInputFeeder, getNumberType, getNumberTypeFP, getNumberValue, getNumberValueDeferred, getNumberValueExact, getObjectId, getReadCapabilities, getSchema, getShortValue, getText, getTokenLocation, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, isEnabled, isNaN, nextBooleanValue, nextFieldName, nextFieldName, nextIntValue, nextLongValue, nextTextValue, overrideFormatFeatures, overrideStdFeatures, readBinaryValue, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, releaseBuffered, requiresCustomCodec, setCodec, setCurrentValue, setFeatureMask, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema, version`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### INT_TAB

    protected static final int INT_TAB

See Also:
  Constant Field Values

#### INT_LF

    protected static final int INT_LF

See Also:
  Constant Field Values

#### INT_CR

    protected static final int INT_CR

See Also:
  Constant Field Values

#### INT_SPACE

    protected static final int INT_SPACE

See Also:
  Constant Field Values

#### INT_LBRACKET

    protected static final int INT_LBRACKET

See Also:
  Constant Field Values

#### INT_RBRACKET

    protected static final int INT_RBRACKET

See Also:
  Constant Field Values

#### INT_LCURLY

    protected static final int INT_LCURLY

See Also:
  Constant Field Values

#### INT_RCURLY

    protected static final int INT_RCURLY

See Also:
  Constant Field Values

#### INT_QUOTE

    protected static final int INT_QUOTE

See Also:
  Constant Field Values

#### INT_APOS

    protected static final int INT_APOS

See Also:
  Constant Field Values

#### INT_BACKSLASH

    protected static final int INT_BACKSLASH

See Also:
  Constant Field Values

#### INT_SLASH

    protected static final int INT_SLASH

See Also:
  Constant Field Values

#### INT_ASTERISK

    protected static final int INT_ASTERISK

See Also:
  Constant Field Values

#### INT_COLON

    protected static final int INT_COLON

See Also:
  Constant Field Values

#### INT_COMMA

    protected static final int INT_COMMA

See Also:
  Constant Field Values

#### INT_HASH

    protected static final int INT_HASH

See Also:
  Constant Field Values

#### INT_0

    protected static final int INT_0

See Also:
  Constant Field Values

#### INT_9

    protected static final int INT_9

See Also:
  Constant Field Values

#### INT_MINUS

    protected static final int INT_MINUS

See Also:
  Constant Field Values

#### INT_PLUS

    protected static final int INT_PLUS

See Also:
  Constant Field Values

#### INT_PERIOD

    protected static final int INT_PERIOD

See Also:
  Constant Field Values

#### INT_e

    protected static final int INT_e

See Also:
  Constant Field Values

#### INT_E

    protected static final int INT_E

See Also:
  Constant Field Values

#### CHAR_NULL

    protected static final char CHAR_NULL

See Also:
  Constant Field Values

#### NO_BYTES

    protected static final byte[] NO_BYTES

Since:
  2.9

#### NO_INTS

    protected static final int[] NO_INTS

Since:
  2.9

#### NR_UNKNOWN

    protected static final int NR_UNKNOWN

See Also:
  Constant Field Values

#### NR_INT

    protected static final int NR_INT

See Also:
  Constant Field Values

#### NR_LONG

    protected static final int NR_LONG

See Also:
  Constant Field Values

#### NR_BIGINT

    protected static final int NR_BIGINT

See Also:
  Constant Field Values

#### NR_DOUBLE

    protected static final int NR_DOUBLE

See Also:
  Constant Field Values

#### NR_BIGDECIMAL

    protected static final int NR_BIGDECIMAL

See Also:
  Constant Field Values

#### NR_FLOAT

    protected static final int NR_FLOAT

NOTE! Not used by JSON implementation but used by many of binary codecs

Since:
  2.9
See Also:
  Constant Field Values

#### BI_MIN_INT

    protected static final BigInteger BI_MIN_INT

#### BI_MAX_INT

    protected static final BigInteger BI_MAX_INT

#### BI_MIN_LONG

    protected static final BigInteger BI_MIN_LONG

#### BI_MAX_LONG

    protected static final BigInteger BI_MAX_LONG

#### BD_MIN_LONG

    protected static final BigDecimal BD_MIN_LONG

#### BD_MAX_LONG

    protected static final BigDecimal BD_MAX_LONG

#### BD_MIN_INT

    protected static final BigDecimal BD_MIN_INT

#### BD_MAX_INT

    protected static final BigDecimal BD_MAX_INT

#### MIN_INT_L

    protected static final long MIN_INT_L

See Also:
  Constant Field Values

#### MAX_INT_L

    protected static final long MAX_INT_L

See Also:
  Constant Field Values

#### MIN_LONG_D

    protected static final double MIN_LONG_D

See Also:
  Constant Field Values

#### MAX_LONG_D

    protected static final double MAX_LONG_D

See Also:
  Constant Field Values

#### MIN_INT_D

    protected static final double MIN_INT_D

See Also:
  Constant Field Values

#### MAX_INT_D

    protected static final double MAX_INT_D

See Also:
  Constant Field Values

#### MAX_ERROR_TOKEN_LENGTH

    @Deprecated
    protected static final int MAX_ERROR_TOKEN_LENGTH

Deprecated. Since 2.16. `ErrorReportConfiguration.getMaxErrorTokenLength()` will be used instead.
Maximum number of characters to include in token reported as part of error messages.

Since:
  2.9
See Also:
  Constant Field Values

#### _streamReadConstraints

    protected final StreamReadConstraints _streamReadConstraints

Since:
  2.18 (was higher up in `ParserBase` before)

#### _currToken

    protected JsonToken _currToken

Last token retrieved via `nextToken()`, if any. Null before the first call to `nextToken()`, as well as if token has been explicitly cleared

#### _tokenCount

    protected long _tokenCount

Current count of tokens, if tracked (see `_trackMaxTokenCount`)

Since:
  2.18

#### _trackMaxTokenCount

    protected final boolean _trackMaxTokenCount

Whether or not to track the token count due a `StreamReadConstraints` maxTokenCount > 0.

Since:
  2.18

#### _lastClearedToken

    protected JsonToken _lastClearedToken

Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.

### Constructor Detail

#### ParserMinimalBase

    @Deprecated
    protected ParserMinimalBase()

Deprecated.

#### ParserMinimalBase

    @Deprecated
    protected ParserMinimalBase(int features)

Deprecated.

#### ParserMinimalBase

    protected ParserMinimalBase(StreamReadConstraints src)

#### ParserMinimalBase

    protected ParserMinimalBase(int features,
                                StreamReadConstraints src)

### Method Detail

#### streamReadConstraints

    public StreamReadConstraints streamReadConstraints()

Description copied from class: `JsonParser`
Get the constraints to apply when performing streaming reads.

Overrides:
  `streamReadConstraints` in class `JsonParser`
Returns:
  Read constraints used by this parser

#### nextToken

    public abstract JsonToken nextToken()
                                 throws IOException

Description copied from class: `JsonParser`
Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.

Specified by:
  `nextToken` in class `JsonParser`
Returns:
  Next token from the stream, if any found, or null to indicate end-of-input
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### currentToken

    public JsonToken currentToken()

Description copied from class: `JsonParser`
Accessor to find which token parser currently points to, if any; null will be returned if none. If return value is non-null, data associated with the token is available via other accessor methods.

Overrides:
  `currentToken` in class `JsonParser`
Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and after end-of-input has been encountered, as well as if the current token has been explicitly cleared.

#### currentTokenId

    public int currentTokenId()

Description copied from class: `JsonParser`
Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).

Use of int directly is typically more efficient on switch statements, so this method may be useful when building low-overhead codecs. Note, however, that effect may not be big enough to matter: make sure to profile performance before deciding to use this method.

Overrides:
  `currentTokenId` in class `JsonParser`
Returns:
  `int` matching one of constants from `JsonTokenId`.

#### getCurrentToken

    public JsonToken getCurrentToken()

Description copied from class: `JsonParser`
Alias for `JsonParser.currentToken()`, may be deprecated sometime after Jackson 2.13 (will be removed from 3.0).

Specified by:
  `getCurrentToken` in class `JsonParser`
Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and

#### getCurrentTokenId

    @Deprecated
    public int getCurrentTokenId()

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias for `JsonParser.currentTokenId()`.

Specified by:
  `getCurrentTokenId` in class `JsonParser`
Returns:
  `int` matching one of constants from `JsonTokenId`.

#### hasCurrentToken

    public boolean hasCurrentToken()

Description copied from class: `JsonParser`
Method for checking whether parser currently points to a token (and data for that token is available). Equivalent to check for `parser.getCurrentToken() != null`.

Specified by:
  `hasCurrentToken` in class `JsonParser`
Returns:
  True if the parser just returned a valid token via `JsonParser.nextToken()`; false otherwise (parser was just constructed, encountered end-of-input and returned null from `JsonParser.nextToken()`, or the token has been consumed)

#### hasTokenId

    public boolean hasTokenId(int id)

Description copied from class: `JsonParser`
Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

Specified by:
  `hasTokenId` in class `JsonParser`
Parameters:
  `id` - Token id to match (from (@link JsonTokenId})
Returns:
  `True` if the parser current points to specified token

#### hasToken

    public boolean hasToken(JsonToken t)

Description copied from class: `JsonParser`
Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

Specified by:
  `hasToken` in class `JsonParser`
Parameters:
  `t` - Token to match
Returns:
  `True` if the parser current points to specified token

#### isExpectedStartArrayToken

    public boolean isExpectedStartArrayToken()

Description copied from class: `JsonParser`
Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected. For some specialized parsers this can return true for other cases as well; this is usually done to emulate arrays in cases underlying format is ambiguous (XML, for example, has no format-level difference between Objects and Arrays; it just has elements).

Default implementation is equivalent to:

       currentToken() == JsonToken.START_ARRAY

but may be overridden by custom parser implementations.

Overrides:
  `isExpectedStartArrayToken` in class `JsonParser`
Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_ARRAY`); `false` if not

#### isExpectedStartObjectToken

    public boolean isExpectedStartObjectToken()

Description copied from class: `JsonParser`
Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.

Overrides:
  `isExpectedStartObjectToken` in class `JsonParser`
Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_OBJECT`); `false` if not

#### isExpectedNumberIntToken

    public boolean isExpectedNumberIntToken()

Description copied from class: `JsonParser`
Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.VALUE_NUMBER_INT`.

The initial use case is for XML backend to efficiently (attempt to) coerce textual content into numbers.

Overrides:
  `isExpectedNumberIntToken` in class `JsonParser`
Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.VALUE_NUMBER_INT`); `false` if not

#### nextValue

    public JsonToken nextValue()
                        throws IOException

Description copied from class: `JsonParser`
Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers). Or put another way, nextToken() will be called once, and if `JsonToken.FIELD_NAME` is returned, another time to get the value for the field. Method is most useful for iterating over value entries of JSON objects; field name will still be available by calling `JsonParser.currentName()` when parser points to the value.

Specified by:
  `nextValue` in class `JsonParser`
Returns:
  Next non-field-name token from the stream, if any found, or null to indicate end-of-input (or, for non-blocking parsers, `JsonToken.NOT_AVAILABLE` if no tokens were available yet)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### skipChildren

    public JsonParser skipChildren()
                            throws IOException

Description copied from class: `JsonParser`
Method that will skip all child tokens of an array or object token that the parser currently points to, if (and only if) stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`. If not, it will do nothing. After skipping, stream will point to matching `JsonToken.END_OBJECT` or `JsonToken.END_ARRAY` (possibly skipping nested pairs of START/END OBJECT/ARRAY tokens as well as value tokens). The idea is that after calling this method, application will call `JsonParser.nextToken()` to point to the next available token, if any.

Specified by:
  `skipChildren` in class `JsonParser`
Returns:
  This parser, to allow call chaining
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _handleEOF

    protected abstract void _handleEOF()
                                throws JsonParseException

Method sub-classes need to implement for verifying that end-of-content is acceptable at current input position.

Throws:
  `JsonParseException` - If end-of-content is not acceptable (for example, missing end-object or end-array tokens)

#### getCurrentName

    @Deprecated
    public abstract String getCurrentName()
                                               throws IOException

Deprecated.
Description copied from class: `JsonParser`
Deprecated alias of `JsonParser.currentName()`.

Specified by:
  `getCurrentName` in class `JsonParser`
Returns:
  Name of the current field in the parsing context
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### close

    public abstract void close()
                        throws IOException

Description copied from class: `JsonParser`
Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled. Whether parser owns the input source depends on factory method that was used to construct instance (so check `JsonFactory` for details, but the general idea is that if caller passes in closable resource (such as `InputStream` or `Reader`) parser does NOT own the source; but if it passes a reference (such as `File` or `URL` and creates stream or reader it does own them.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `JsonParser`
Throws:
  `IOException` - if there is either an underlying I/O problem

#### isClosed

    public abstract boolean isClosed()

Description copied from class: `JsonParser`
Method that can be called to determine whether this parser is closed or not. If it is closed, no new tokens can be retrieved by calling `JsonParser.nextToken()` (and the underlying stream may be closed). Closing may be due to an explicit call to `JsonParser.close()` or because parser has encountered end of input.

Specified by:
  `isClosed` in class `JsonParser`
Returns:
  `True` if this parser instance has been closed

#### getParsingContext

    public abstract JsonStreamContext getParsingContext()

Description copied from class: `JsonParser`
Method that can be used to access current parsing context reader is in. There are 3 different types: root, array and object contexts, with slightly different available information. Contexts are hierarchically nested, and can be used for example for figuring out part of the input document that correspond to specific array or object (for highlighting purposes, or error reporting). Contexts can also be used for simple xpath-like matching of input, if so desired.

Specified by:
  `getParsingContext` in class `JsonParser`
Returns:
  Stream input context (`JsonStreamContext`) associated with this parser

#### currentTokenCount

    public long currentTokenCount()

Description copied from class: `JsonParser`
Get an approximate count of the number of tokens that have been read. This count is likely to be only updated if `StreamReadConstraints.Builder.maxTokenCount(long)` has been used to set a limit on the number of tokens that can be read.

Overrides:
  `currentTokenCount` in class `JsonParser`
Returns:
  the number of tokens that have been read (-1 if the count is not available)

#### clearCurrentToken

    public void clearCurrentToken()

Description copied from class: `JsonParser`
Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null). Cleared token value can still be accessed by calling `JsonParser.getLastClearedToken()` (if absolutely needed), but usually isn't.

Method was added to be used by the optional data binder, since it has to be able to consume last token used for binding (so that it will not be used again).

Specified by:
  `clearCurrentToken` in class `JsonParser`

#### getLastClearedToken

    public JsonToken getLastClearedToken()

Description copied from class: `JsonParser`
Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`. This is not necessarily the latest token read. Will return null if no tokens have been cleared, or if parser has been closed.

Specified by:
  `getLastClearedToken` in class `JsonParser`
Returns:
  Last cleared token, if any; `null` otherwise

#### overrideCurrentName

    public abstract void overrideCurrentName(String name)

Description copied from class: `JsonParser`
Method that can be used to change what is considered to be the current (field) name. May be needed to support non-JSON data formats or unusual binding conventions; not needed for typical processing.

Note that use of this method should only be done as sort of last resort, as it is a work-around for regular operation.

Specified by:
  `overrideCurrentName` in class `JsonParser`
Parameters:
  `name` - Name to use as the current name; may be null.

#### getText

    public abstract String getText()
                            throws IOException

Description copied from class: `JsonParser`
Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.

Specified by:
  `getText` in class `JsonParser`
Returns:
  Textual value associated with the current token (one returned by `JsonParser.nextToken()` or other iteration methods)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

#### getTextCharacters

    public abstract char[] getTextCharacters()
                                      throws IOException

Description copied from class: `JsonParser`
Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:

- Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
- Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

Specified by:
  `getTextCharacters` in class `JsonParser`
Returns:
  Buffer that contains the current textual value (but not necessarily at offset 0, and not necessarily until the end of buffer)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

#### hasTextCharacters

    public abstract boolean hasTextCharacters()

Description copied from class: `JsonParser`
Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

Specified by:
  `hasTextCharacters` in class `JsonParser`
Returns:
  True if parser currently has character array that can be efficiently returned via `JsonParser.getTextCharacters()`; false means that it may or may not exist

#### getTextLength

    public abstract int getTextLength()
                               throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.

Specified by:
  `getTextLength` in class `JsonParser`
Returns:
  Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getTextOffset

    public abstract int getTextOffset()
                               throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.

Specified by:
  `getTextOffset` in class `JsonParser`
Returns:
  Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getBinaryValue

    public abstract byte[] getBinaryValue(Base64Variant b64variant)
                                   throws IOException

Description copied from class: `JsonParser`
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

Specified by:
  `getBinaryValue` in class `JsonParser`
Parameters:
  `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
Returns:
  Decoded binary data
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsBoolean

    public boolean getValueAsBoolean(boolean defaultValue)
                              throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

If representation cannot be converted to a boolean value (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsBoolean` in class `JsonParser`
Parameters:
  `defaultValue` - Default value to return if conversion to `boolean` is not possible
Returns:
  `boolean` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsInt

    public int getValueAsInt()
                      throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a Java `int` value. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation cannot be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

Overrides:
  `getValueAsInt` in class `JsonParser`
Returns:
  `int` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsInt

    public int getValueAsInt(int defaultValue)
                      throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation cannot be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsInt` in class `JsonParser`
Parameters:
  `defaultValue` - Default value to return if conversion to `int` is not possible
Returns:
  `int` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsLong

    public long getValueAsLong()
                        throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation cannot be converted to a long (including structured type markers like start/end Object/Array) default value of 0L will be returned; no exceptions are thrown.

Overrides:
  `getValueAsLong` in class `JsonParser`
Returns:
  `long` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsLong

    public long getValueAsLong(long defaultValue)
                        throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation cannot be converted to a long (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsLong` in class `JsonParser`
Parameters:
  `defaultValue` - Default value to return if conversion to `long` is not possible
Returns:
  `long` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsDouble

    public double getValueAsDouble(double defaultValue)
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language floating point parsing rules.

If representation cannot be converted to a double (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Overrides:
  `getValueAsDouble` in class `JsonParser`
Parameters:
  `defaultValue` - Default value to return if conversion to `double` is not possible
Returns:
  `double` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsString

    public String getValueAsString()
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation cannot be converted to a String value (including structured types like Objects and Arrays and `null` token), default value of null will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `JsonParser`
Returns:
  `String` value current token is converted to, if possible; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsString

    public String getValueAsString(String defaultValue)
                            throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation cannot be converted to a String value (including structured types like Objects and Arrays and `null` token), specified default value will be returned; no exceptions are thrown.

Specified by:
  `getValueAsString` in class `JsonParser`
Parameters:
  `defaultValue` - Default value to return if conversion to `String` is not possible
Returns:
  `String` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _decodeBase64

    protected void _decodeBase64(String str,
                                 ByteArrayBuilder builder,
                                 Base64Variant b64variant)
                          throws IOException

Helper method that can be used for base64 decoding in cases where encoded content has already been read as a String.

Parameters:
  `str` - String to decode
  `builder` - Builder used to buffer binary content decoded
  `b64variant` - Base64 variant expected in content
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _hasTextualNull

    protected boolean _hasTextualNull(String value)

Helper method used to determine whether we are currently pointing to a String value of "null" (NOT a null token); and, if so, that parser is to recognize and return it similar to if it was real null token.

Default implementation accepts exact string `"null"` and nothing else

Parameters:
  `value` - String value to check
Returns:
  True if given value contains "null equivalent" String value (for content this parser handles).
Since:
  2.3

#### _reportInputCoercion

    protected void _reportInputCoercion(String msg,
                                        JsonToken inputType,
                                        Class<?> targetType)
                                 throws InputCoercionException

Throws:
  `InputCoercionException`

#### _reportInvalidEOF

    protected void _reportInvalidEOF()
                              throws JsonParseException

Throws:
  `JsonParseException`

#### _reportInvalidEOFInValue

    protected void _reportInvalidEOFInValue(JsonToken type)
                                     throws JsonParseException

Throws:
  `JsonParseException`

#### _reportInvalidEOF

    protected void _reportInvalidEOF(String msg,
                                     JsonToken currToken)
                              throws JsonParseException

Throws:
  `JsonParseException`

#### reportInvalidNumber

    protected void reportInvalidNumber(String msg)
                                throws JsonParseException

Method called to throw an exception for input token that looks like a number based on first character(s), but is not valid according to rules of format. In case of JSON this also includes invalid forms like positive sign and leading zeroes.

Parameters:
  `msg` - Base exception message to use
Throws:
  `JsonParseException` - Exception that describes problem with number validity

#### _reportMissingRootWS

    protected void _reportMissingRootWS(int ch)
                                 throws JsonParseException

Throws:
  `JsonParseException`

#### reportOverflowInt

    protected void reportOverflowInt()
                              throws IOException

Method called to throw an exception for integral (not floating point) input token with value outside of Java signed 32-bit range when requested as `int`. Result will be `InputCoercionException` being thrown.

Throws:
  `JsonParseException` - Exception that describes problem with number range validity
  `IOException`

#### reportOverflowInt

    protected void reportOverflowInt(String numDesc)
                              throws IOException

Throws:
  `IOException`

#### reportOverflowInt

    protected void reportOverflowInt(String numDesc,
                                     JsonToken inputType)
                              throws IOException

Throws:
  `IOException`

#### reportOverflowLong

    protected void reportOverflowLong()
                               throws IOException

Method called to throw an exception for integral (not floating point) input token with value outside of Java signed 64-bit range when requested as `long`. Result will be `InputCoercionException` being thrown.

Throws:
  `JsonParseException` - Exception that describes problem with number range validity
  `IOException`

#### reportOverflowLong

    protected void reportOverflowLong(String numDesc)
                               throws IOException

Throws:
  `IOException`

#### reportOverflowLong

    protected void reportOverflowLong(String numDesc,
                                      JsonToken inputType)
                               throws IOException

Throws:
  `IOException`

#### _longIntegerDesc

    protected String _longIntegerDesc(String rawNum)

#### _longNumberDesc

    protected String _longNumberDesc(String rawNum)

#### _reportUnexpectedChar

    protected void _reportUnexpectedChar(int ch,
                                         String comment)
                                  throws JsonParseException

Throws:
  `JsonParseException`

#### _reportUnexpectedNumberChar

    protected <T> T _reportUnexpectedNumberChar(int ch,
                                                String comment)
                                         throws JsonParseException

Type Parameters:
  `T` - Nominal type for bogus return value
Parameters:
  `ch` - Character that was unexpected
  `comment` - Additional failure comment to add, if any
Returns:
  Nothing, just declared to let caller use `return` when calling this method, to keep compiler happy.
Throws:
  `JsonParseException` - constructed with `JsonParser._constructReadException(String, JsonLocation)`
Since:
  2.14

#### reportUnexpectedNumberChar

    @Deprecated
    protected void reportUnexpectedNumberChar(int ch,
                                                          String comment)
                                                   throws JsonParseException

Deprecated.

Throws:
  `JsonParseException`

#### _throwInvalidSpace

    protected void _throwInvalidSpace(int i)
                               throws JsonParseException

Throws:
  `JsonParseException`

#### _constructError

    protected final JsonParseException _constructError(String msg,
                                                       Throwable t)

#### _currentLocationMinusOne

    protected JsonLocation _currentLocationMinusOne()

Factory method used to provide location for cases where we must read and consume a single "wrong" character (to possibly allow error recovery), but need to report accurate location for that character: if so, the current location is past location we want, and location we want will be "one location earlier".

Default implementation simply returns `JsonParser.currentLocation()`

Returns:
  Same as `JsonParser.currentLocation()` except offset by -1
Since:
  2.17

#### _getCharDesc

    protected static final String _getCharDesc(int ch)

#### _reportError

    protected final void _reportError(String msg)
                               throws JsonParseException

Throws:
  `JsonParseException`

#### _reportError

    protected final void _reportError(String msg,
                                      Object arg)
                               throws JsonParseException

Throws:
  `JsonParseException`

#### _reportError

    protected final void _reportError(String msg,
                                      Object arg1,
                                      Object arg2)
                               throws JsonParseException

Throws:
  `JsonParseException`

#### _throwInternal

    protected final void _throwInternal()

#### _throwInternalReturnAny

    protected final <T> T _throwInternalReturnAny()

#### _wrapError

    protected final void _wrapError(String msg,
                                    Throwable t)
                             throws JsonParseException

Throws:
  `JsonParseException`

#### _updateToken

    protected final JsonToken _updateToken(JsonToken token)
                                    throws StreamConstraintsException

Throws:
  `StreamConstraintsException`

#### _nullSafeUpdateToken

    protected final JsonToken _nullSafeUpdateToken(JsonToken token)
                                            throws StreamConstraintsException

Throws:
  `StreamConstraintsException`

#### _updateTokenToNull

    protected final JsonToken _updateTokenToNull()

#### _updateTokenToNA

    protected final JsonToken _updateTokenToNA()

#### _asciiBytes

    @Deprecated
    protected static byte[] _asciiBytes(String str)

Deprecated.

#### _ascii

    @Deprecated
    protected static String _ascii(byte[] b)

Deprecated.